import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/fetchData/makeDocument.ts";
import { OT, pipe, T } from '@contentlayer/utils/effect';
import { getFieldData } from '../mapping/index.js';
import { fetchPageContent } from '../notion/fetchPageContent.js';
export const makeDocument = ({ documentTypeDef, databaseTypeDef, page, options }) => (OT.withSpan('@contentlayer/source-notion/fetchData:makeDocument')(T.chain_(T.forEachParDict_(documentTypeDef.fieldDefs.filter((f) => !f.isSystemField), {
    mapKey: (fieldDef) => T.succeed(fieldDef.name, fileName_1 + ":21:38"),
    mapValue: (fieldDef) => {
        const databaseFieldTypeDef = databaseTypeDef.properties?.find((field) => field.key === fieldDef.propertyKey);
        return getFieldData({
            fieldDef,
            property: page.properties[fieldDef.propertyKey],
            databaseFieldTypeDef,
            databaseTypeDef,
            documentTypeDef,
        });
    },
}), (docValues) => T.gen(function* ($) {
    const document = {
        ...docValues,
        [options.fieldOptions.typeFieldName]: documentTypeDef.name,
        _id: page.id,
        _raw: {},
        ...(databaseTypeDef.importContent !== false
            ? {
                [options.fieldOptions.bodyFieldName]: {
                    html: yield* $(fetchPageContent({ page }), fileName_1 + ":44:33"),
                },
            }
            : {}),
    };
    return document;
}, fileName_1 + ":35:12"), fileName_1 + ":34:12")));
//# sourceMappingURL=makeDocument.js.map